#!/usr/bin/env python3

import numpy as np

from scatteringtree import scattering_tree
from filters.swt import swt1
from nonlinearity import ReLu
from pooling import pooling


from nonlinearity import *

from visualize import visualize_tree

from scipy.misc import imresize



if __name__ == '__main__':
    
    # initialize scattering transform

    prop_filters = [
                        [swt1(wavelet='db1', level=3, start_level=0, frequency_decreasing_path=False)],
                        [swt1(wavelet='db1', level=3, start_level=0, frequency_decreasing_path=False)],
                        [swt1(wavelet='db1', level=3, start_level=0, frequency_decreasing_path=False)],
                        [],
                    ]
                    
    nls = [
        ReLu,
        ReLu,
        ReLu,
        ReLu,
    ]

    pools = [
                pooling(2, np.mean),
                pooling(2, np.mean),
                pooling(2, np.mean),
                pooling(2, np.mean),
                ]
                                    
    sct = scattering_tree(
                            propagation_filters=prop_filters,
                            nonlinearities=nls,
                            poolings=pools
                            )


    signal = np.array([0,1,2,5,8,12,16,18,19,19,18,17,15,12,9,7,6,3,1,-4,-10,-12,-12,-11,-9,-7,-5,-4,-3,-2,-1,0])
    visualize_tree(sct, signal)

    
